/**
 * Audio.js
 * 
 */
//define(["jquery", "lib/util/classUtils", "lib/jquery.mb.audio", "thirdparty/jquery/plugins/jquery.easing.1.3"], function($, classUtils, mbAudio) {
define(["jquery", "lib/util/classUtils", "Howler", "thirdparty/jquery/plugins/jquery.easing.1.3", "lib/swfobject"], function($, classUtils, howler) {

	"use strict";
	
	return classUtils.create({
	
		myVar: null,
		is_mobile: !!(/Android|webOS|iPhone|iPad|iPod|BlackBerry|Kindle/i.test(navigator.userAgent) || (/Android|webOS|iPhone|iPad|iPod|BlackBerry|Kindle/i.test(navigator.platform))),
		htmlAudio: !!(document.createElement('audio').canPlayType) && !(/msie/i.test(navigator.userAgent) || (/msie/i.test(navigator.platform))),
		// htmlAudio: false, 
		i: 0,
		$audioDiv: $('#hideme'),
		mutebg: 0,
		muteall: 0,
		bgm_howl: null,
		audio_nodes: new Array(),
		htmlSoundsLoaded: false,
		htmlSoundsLoadedCounter: 0,
		audioXml: null,
		
		init: function(){
			window.sb_soundSpriteIds = [
				{id:'cachsprite', sprites:[
					{id:'can_do_it', start:0, duration:1.4},
					{id:'play_again', start:1.5, duration:1.3},
					{id:'help', start:3, duration:0.6},
					{id:'cool', start:4, duration:0.7},
					{id:'cargo_chaos', start:5, duration:1.5},
					{id:'be_quick', start:6.5, duration:1.1},
					{id:'play', start:8, duration:0.6},
					{id:'running_out', start:9, duration:11.2}
				]},				    				
			];			
		},
		
		
		addAudio: function(src, id){
			
			/*
			var self = this;
			
			var loop = '';
			
			if(id === 'bg'){
				
				loop = "loop";
				
			}
			self.$audioDiv.append('<audio id="audio_'+ id +'" '+loop+' preload ><source class="mp3" type="audio/mpeg"></source><source class="ogg" type="audio/ogg"></source></audio>');
			$('#audio_'+ id +' .mp3')
		    .attr('src',
		       src+'.mp3')
		    .detach().appendTo($('#audio_'+ id +''));
		    $('#audio_'+ id +' .ogg')
		    .attr('src',
		       src+'.ogg')
		    .detach().appendTo($('#audio_'+ id +''));
		    
		    var audioPlays = document.getElementById("audio_"+ id);
		    
		    audioPlays.play();
 			audioPlays.pause(); 
 				    
		    return "audio_"+ id;*/
			
			for(var i = 0; i < window.sb_soundSpriteIds.length; i++)
			{
				/*
				 * 
				 * FIXME currently just adding all audio to the very start of the app in initSoundSprite, would be better to add it here in the preload function but didn't work for some reason.
				 * 
				if(window.sb_soundSpriteIds[i].id == id)
				{
					console.log("loading audio - " + id);
					var sprites = {};
					
					for(var j = 0; j < window.sb_soundSpriteIds[i].sprites.length; j++)
					{
						sprites[window.sb_soundSpriteIds[i].sprites[j].id] = [window.sb_soundSpriteIds[i].sprites[j].start * 1000, window.sb_soundSpriteIds[i].sprites[j].duration * 1000];
						console.log("sprite - " + window.sb_soundSpriteIds[i].sprites[j].id);
					}	
					
					var howl = new howler.Howl({
						urls:[ + window.sbBaseURL + 'assets/audio/sprites/' + window.sb_soundSpriteIds[i].id + '.mp3', ' + window.sbBaseURL + 'assets/audio/sprites/' + window.sb_soundSpriteIds[i].id + '.ogg'],
						sprite:sprites
					});
					
					howl.play();
	
					window.sb_soundSprites.push(howl);
				}*/
			}
			
			return "audio_"+ id;
		},
		
		initAudio: function(audio_js){
			
			var self = this;
			
			var initTimer;
					
			var divID = "audioplayer";
			
			if(self.htmlAudio === false) {
				
				$(audio_js).find("sound_node").each(function(){
					
					self.audio_nodes[$(this).attr('id')] = new Array();
					
					self.audio_nodes[$(this).attr('id')]['name_id'] = $.trim($(this).find('name').text());
					
					self.audio_nodes[$(this).attr('id')]['mp3'] = $.trim($(this).find('audio_source').text());
				
						
				});
				
		
				var flashvars = {
		            path: '',
		            debug_mode: 'false'
		        };
		        var params = {
		            menu: "false",
		            scale: "noScale",
		            allowFullscreen: "true",
		            allowScriptAccess: "always",
		            allowNetworking: "all",
		            bgcolor: "#ffffff"
		        };
		        var attributes = {
		            id:"audio_player"
		        };
		        swfobject.embedSWF(window.sbBaseURL + "audio_player.swf", "altContent", "1", "1", "10.0.0", "js/expressInstall.swf", flashvars, params, attributes);
		        
		        var swfTimer = setInterval(function()
		        {
		        	if(window.flashSwfLoaded === true)
		        	{
		        		clearInterval(swfTimer);
		        		$('#audio_player').css({'visibility':'true'})
		        		document.getElementById('audio_player').add_xml(audio_js);
		        	}
		        }, 100);
		        
		        window.flashLoaded = false;
		        
		        initTimer = setInterval(function()
		        {
					if(window.flashLoaded === true){
						
						clearInterval(initTimer);
						self.soundsLoaded =  50;
						$(window).trigger("loadFinished", "loadFinished");
						
					}else{
						
						//initTimer;
					}
					
				}, 100);
		        
		        
				//
			}else{

				// the array containing all of the sound for the page
				$(audio_js).find("sound_node").each(function(){
					
					self.audio_nodes[$(this).attr('id')] = new Array();
					
/* 					self.audio_nodes[$(this).attr('id')]['subtitles'] =  $(this); */
					self.audio_nodes[$(this).attr('id')]['name_id'] = $.trim($(this).find('name').text());
					
					self.audio_nodes[$(this).attr('id')]['mp3'] = $.trim($(this).find('audio_source').text());
/* 					self.audio_nodes[$(this).attr('id')]['duration'] =  $.trim($(this).find('audio_duration').text()); */

					if($('#audio_' + self.audio_nodes[$(this).attr('id')]['name_id']).length === 0){
											
						self.audio_nodes[$(this).attr('id')]['player'] = self.addAudio(self.audio_nodes[$(this).attr('id')]['mp3'] , self.audio_nodes[$(this).attr('id')]['name_id']);
					
					
					// here's where I need to put the code to make sure self all html sounds have loaded.
					
						/*if(self.is_mobile === false){
						
							var audioPlays = document.getElementById(self.audio_nodes[$(this).attr('id')]['player']);
							
							audioPlays.addEventListener("canplaythrough", function(){
							
								self.htmlSoundsLoadedCounter++;
							});
						
						}else{*/
							
							self.htmlSoundsLoadedCounter = (self.audio_nodes.length-1);
							
						//}
					
					}else{
						
						self.htmlSoundsLoadedCounter = (self.audio_nodes.length-1);
						
					}
						
				});
				
				//timer to check all has loaded here.
				initTimer = setInterval(function(){
						
					if(self.htmlSoundsLoadedCounter === (self.audio_nodes.length-1)){
						self.soundsLoaded = 50;
						clearInterval(initTimer);
						$(window).trigger("loadFinished", "loadFinished");
					}
					
				}, 100);
					
			}
		},
		
		playAudio: function(id, numId){
		
			var self = this;
			// if(window.muteall === 1){
				if(self.htmlAudio === true){
					if(!self.isSoundSprite(id)){
						/*
						var audioPlays = document.getElementById(id);
						if(audioPlays.duration > 0 && !audioPlays.paused){
					    			
		    				//already playing
			    			audioPlays.pause();
			    			audioPlays.currentTime = 0;
			    			audioPlays.play();
			    			
		    			}else{
		    			
		    				//not playing
			    		
			    			audioPlays.play();	
			    			
		    			}*/
					}
				}else{
					try
					{
						var flashPlayer = document.getElementById('audio_player')
						flashPlayer.play_sound_file('audio_' + id);
					}
					catch(e){
					}
				}
			// }
		},
		
		stopAudio: function(id, numId){
		
			var self = this;
		
			if(self.htmlAudio === true){
			
				if(id === 'all'){
					
					for(var i = 0; i < window.sb_soundSprites.length; i++)
					{
						window.sb_soundSprites[i].stop();
					}	
					
					/*
					$('audio').each(function(){
					
						var thisId = $(this).attr('id');
						var audioPlays = document.getElementById(thisId);
						audioPlays.pause();
						if(audioPlays.currentTime !== 0){
							audioPlays.currentTime = 0;
						}
					});*/
					
				}else{
					
					for(var i = 0; i < window.sb_soundSpriteIds.length; i++){
						for(var j = 0; j < window.sb_soundSpriteIds[i].sprites.length; j++){
							if(window.sb_soundSpriteIds[i].sprites[j].id === id){
								window.sb_soundSprites[i].stop();
							}	
						}	
					}
					
					/*
					var audioPlays = document.getElementById(id);
					audioPlays.pause();
					if(audioPlays.currentTime !== 0){
						audioPlays.currentTime = 0;
					}*/
				}
			}else{
			
				if ($("#audio_player").length > 0){
					if(id === 'all'){
						try
						{
							document.getElementById('audio_player').stop_all_audio();
						}
						catch(e){}
					} else {
						try
						{
							document.getElementById('audio_player').stop_sound_file(id);
						}
						catch(e){
						}
					}
				}
				
			}
			
		},
		
		isHTMLAudioPlaying: function(id){
			
			var audio = document.getElementById(id);

			if(audio.duration > 0 && !audio.paused) {

			    return true;
			} else {

			    return false;
			}
		},
		
		removeAudio: function(id){

			var audioPlays = document.getElementById(id);
			audioPlays.pause();
		    audioPlays.currentTime = 0;
		    
		    $('#'+id).remove();
			
		},
		
		toggleMute: function(){
			
			var self = this;
				
			if (window.muteall === 0){
				window.muteall = 1;
			} else {
				window.muteall = 0;
			}
			 
			
			if(self.htmlAudio === true){
				
				if (window.muteall === 0){
					howler.Howler.mute();
				} else {
					howler.Howler.unmute();
				}
				
				$('audio').each(function(){

					var thisId = $(this).attr('id');
					var audioPlays = document.getElementById(thisId);
					

					if(window.muteall == 1){
					
						audioPlays.volume = 1;
					}else{
	
						audioPlays.volume = 0;
					}
					
				})
				
			}else{
			
				if ($("#audio_player").length > 0){

					if(window.muteall === 0){
					
						document.getElementById("audio_player").muteSound(0);	
						//window.muteall = 1;
						
					}else{
						
						document.getElementById("audio_player").muteSound(1);
						//window.muteall = 0;
						
					}
				}
				
			}
			
		},
		
		canIPlayThrough: function(id){
			
			var audioPlays = document.getElementById(id);
			audioPlays.addEventListener("canplaythrough", function()
			{
				
			}
			);
			
		},
		
		initSoundSprite: function()
		{
			if(!window.sb_ie)
			{	
				window.sb_soundSprites = [];
				
				for(var i = 0; i < window.sb_soundSpriteIds.length; i++)
				{
					var sprites = {};
					
					for(var j = 0; j < window.sb_soundSpriteIds[i].sprites.length; j++)
					{
						sprites[window.sb_soundSpriteIds[i].sprites[j].id] = [window.sb_soundSpriteIds[i].sprites[j].start * 1000, window.sb_soundSpriteIds[i].sprites[j].duration * 1000];
					}	
					
					var howl = new howler.Howl({
						urls:[window.sbBaseURL + 'audio/' + window.sb_soundSpriteIds[i].id + '.mp3', window.sbBaseURL + 'audio/' + window.sb_soundSpriteIds[i].id + '.ogg'],
						sprite:sprites
					});
	
					window.sb_soundSprites.push(howl);
				}
			}
		},
		
		playBgSprite: function(){
			var self = this;
			
			if(!this.is_mobile){	
				self.bgm_howl = new howler.Howl({
					urls:[window.sbBaseURL + 'assets/audio/bgm.mp3', window.sbBaseURL + 'assets/audio/bgm.ogg'],
					loop: true,
					volume: 0.5
				}).play();
			}	
				
			
		},
		
		stopBgSprite: function() {
		
			var self = this;
			if(!this.is_mobile){
				self.bgm_howl.stop();
			}	
			
		},
		
		isSoundSprite: function(id)
		{
			for(var i = 0; i < window.sb_soundSpriteIds.length; i++)
			{
				for(var j = 0; j < window.sb_soundSpriteIds[i].sprites.length; j++)
				{
					if(window.sb_soundSpriteIds[i].sprites[j].id === id)
					{
						var play_sound = true;
						
						var ua = navigator.userAgent.toLowerCase();
						var isAndroid = ua.indexOf("android") > -1; //&& ua.indexOf("mobile");
						
						play_sound = true;

						if(play_sound)
						{	
							try
							{
								window.sb_soundSprites[i].play(id);
							}
							catch(e)
							{}
							
							return true;
						}
					}	
				}	
			}
			
			return false;
			
		}

	});
	
});
