define([
         "jquery",
         "thirdparty/jquery/plugins/jquery-ui-1.9.1.custom.min",
         "lib/util/classUtils",
         "lib/util/IsEventSupported",
         "lib/TweenMax.min",
         ],
         function($, ui, classUtils, IsEventSupported, TweenMax) {
		"use strict";
	return classUtils.create({
		game:null,
		id:null,
		holder:null,
		width:20.13,
		height:10,
		top:67,
		left:5,
		distanceBetween:5,
		item:null,
		lid:null,
		holder_left:null,
		carriage:null,
		carriageHolder:null,
		carriageBase:null,
		containerArray:[],
		
		init:function(_id,_that){	
		this.id = _id;
		this.game = _that;
		this.containerArray = [];
		},
			create:function(){
			var that = this;
			var v= null;
			this.containerArray = []; 
			var v = null;
			for(v= 0;v < this.game.container_positions_arr.length;v++ ){
				  this.containerArray[v]  = this.game.container_positions_arr[v];
			}
			this.item = 'cach_container' + this.containerArray[this.id];
			this.holder = $('<div>').attr('class',this.item);
			this.carriageHolder = $('<div>').attr('class', 'shape_'+this.item);
			this.carriageHolder.css('border-style','none');
			
			this.holder.css({
				'position':'absolute',
				'top': this.top+2 + '%',
				"-webkit-user-select": 'none',
				'z-index':'0',
				'visibility':'visible'
			});
			this.carriageHolder.css({
				'position':'absolute',
				'top': this.top + '%',
				"-webkit-user-select": 'none',
				'z-index':'0',
				'visibility':'visible',
				'width':'20%',
				'height':'20%'
			});
			this.holder.css('background-size', '1175.31% 2211.11%');
			this.holder.css('background-image', 'url(images/cargochaos.png)');
			this.holder.css('width','8.58%'); 
			this.holder.css('height','14.04%'); 
			this.holder.css('background-repeat','no-repeat');
			switch (that.containerArray[this.id]) {
			case 0: // square
					this.holder.css('background-position', '72.8% 61.8%');
				break;
			case 1: // circle
					this.holder.css('background-position', '49.7% 74.1%');
			break;
			case 2: // star
				this.holder.css('background-position', '62.8% 61.7%');
			break;
			case 3:// diamond
				this.holder.css('background-position', '49.7% 68.9%');
			break;
		}
			
			this.carriage = $('<div>').attr('class', 'carriage_'+this.item);
			this.carriageBase = $('<div>').attr('class', 'carriage_base_'+this.item);
			// this.carriage.append('<img src="images/container_carriage.png" style="position:absolute; left:0%; top:0%; width:100%; height:100%;" />');
			this.carriage.css('position','absolute');
			this.carriage.css('background-image', 'url(images/cargochaos.png)');
			this.carriage.css('width','100%');
			this.carriage.css('height','100%');
			this.carriage.css('background-repeat','no-repeat');
			this.carriage.css("-webkit-user-select",'none');
			this.carriage.css('background-size', '500% 1600%');
			this.carriage.css('background-position', '71.7% 99.1%');
			
			// this.carriageBase.append('<img src="images/container_carriage_base.png" style="position:absolute; left:0%; top:0%; width:100%; height:100%;" />');
			
			this.carriageBase.css('background-image', 'url(images/cargochaos.png)');
			this.carriageBase.css('position','absolute');
			this.carriageBase.css('width','100%');
			this.carriageBase.css('height','41.35%');
			this.carriageBase.css('background-repeat','no-repeat');
			this.carriageBase.css('top','67%');
			this.carriageBase.css("-webkit-user-select",'none');
			this.carriageBase.css('background-size', '500% 3256.36%');
			this.carriageBase.css('background-position', '79.8% 57.4%');
			
			$('#cach_holder').append(this.carriageHolder);
			$('#cach_holder').append(this.holder);
			this.carriageHolder.append(this.carriage);
			this.carriageHolder.append(this.carriageBase);
			
			this.addInteraction();
		 	this.initTouch();
		},
		
		update_position:function(_new_position){
			var that = this;
		},
		
	
		
		touchHandler:function(event){
		    var touches = event.changedTouches,
		        first = touches[0],
		        type = "";
		    switch(event.type){
		        case "touchstart": type = "mousedown"; break;
		        case "touchmove":  type="mousemove"; break;
		        case "touchend":   type="mouseup"; break;
		        default: return;
		    }
		    var simulatedEvent = document.createEvent("MouseEvent");
		    simulatedEvent.initMouseEvent(type, true, true, window, 1,
		                              first.screenX, first.screenY,
		                              first.clientX, first.clientY, false,
		                              false, false, false, 0/*left*/, null);
		 
		    first.target.dispatchEvent(simulatedEvent);
		    event.preventDefault();
		},
		initTouch:function(){
			  if ($("#cach_holder").get(0).addEventListener) {
				  		 $("#cach_holder").get(0).addEventListener("touchstart", this.touchHandler, true);
				  		 $("#cach_holder").get(0).addEventListener("touchmove", this.touchHandler, true);
				  		 $("#cach_holder").get(0).addEventListener("touchcancel", this.touchHandler, true);
				  		 $("#cach_holder").get(0).addEventListener("touchend", this.touchHandler, true);
				}
		},
		shakeTween:function(repeat){ 
		   var that = this;
	    },
		addInteraction:function(){
			var that = this;
			if (IsEventSupported("touchstart")){
			$('.'+this.item).droppable({
                over: function(){
             	},
             	out: function() {
             	},
              	drop: function() {
              	that.game.checkForMatch(that);
            		 }
            	})
			 }else{
				 $('.'+this.item).on('mouseenter',function(e){
					 e.preventDefault();
					 that.game.hovered_container = that.id;
					 if (that.game.item_selected){
						 TweenMax.to($(that.holder), 0.25, {scaleX:1.05, scaleY:1.05, ease:"Elastic.easeOut"});
						  TweenMax.to($(that.carriage), 0.25, {scaleX:1.05, scaleY:1.05, ease:"Elastic.easeOut"});
					 }
						
					});
				 
				 $('.'+this.item).on('mouseleave',function(e){
					 e.preventDefault();
					 that.game.hovered_container = "none";
					  TweenMax.to($(that.holder), 0.25, {scaleX:1, scaleY:1, ease:"Elastic.easeOut"});
					TweenMax.to($(that.carriage), 0.25, {scaleX:1, scaleY:1, ease:"Elastic.easeOut"});
					});
				 
				 $('.'+this.item).on('click',function(){
				  that.game.checkForMatch_2(that);
					  TweenMax.to((that.item), 0, {scaleX:1, scaleY:1, ease:"Linear.easeIn"});
					});
				 $('.'+this.item).on('mouseup',function(){
					  that.game.checkForMatch_2(that);
						});
			 }
    },
		disable:function(){
			var holder_div = document.getElementById("cach_holder");
					if (IsEventSupported("touchstart")){	
						  holder_div.removeEventListener("touchstart");
				  		  holder_div.removeEventListener("touchmove");
				  		  holder_div.removeEventListener("touchend");
				  		  holder_div.removeEventListener("touchcancel");
					}else{	
						this.holder.off("click");
						$(document).off('keydown');		
					}
		},
		removeContainer:function(_that){
			var that = _that;
			that.carriageHolder.remove();
			that.holder();
		},
		removeInteraction:function(){	
			var target = "."+this.item; 
			var holder_div = document.getElementById("cach_holder");
			if (IsEventSupported("touchstart")){
				$(target).off('mousedown');
				$(target).off('mouseup');
				$(target).off('mouseleave');
				$(target).off('mouseenter');
				  		 $("#cach_holder").get(0).removeEventListener("touchstart", this.touchHandler, true);
				  		 $("#cach_holder").get(0).removeEventListener("touchmove", this.touchHandler, true);
				  		 $("#cach_holder").get(0).removeEventListener("touchcancel", this.touchHandler, true);
				  		 $("#cach_holder").get(0).removeEventListener("touchend", this.touchHandler, true);
					}else{
				 $('.'+this.item).off('mousedown');
				 $('.'+this.item).off('mouseup');
				 $('.'+this.item).off('mouseleave');
				 $('.'+this.item).off('mouseenter');
			 }
		}			
	});
});