define([
         "jquery",
         "lib/util/classUtils",
         "lib/util/IsEventSupported",
         "lib/TweenMax.min",
         "CargoChaos/CaChLevelData",
         "CargoChaos/CaChTitle",
         "CargoChaos/CaChContainer",
         "CargoChaos/CaChTimer",
         "CargoChaos/CaChItem",
         "CargoChaos/CaChTrafficLights",
         "CargoChaos/CaChFeedback",
         "CargoChaos/CaChPlayAgain",
         "CargoChaos/CaChGameTitle",
         "CargoChaos/CaChRocks",
         "CargoChaos/Audio"
         ],
         function($, classUtils, IsEventSupported, TweenMax, CaChLevelData, CaChTitle, CaChContainer,CaChTimer, CaChItem, CaChTrafficLights, CaChFeedback, CaChPlayAgain, CaChGameTitle, CaChRocks, Audio) {
	"use strict";
	return classUtils.create({
		caChLevelData:null,
		levelData:null,
		is_mobile: !!(/Android|webOS|iPhone|iPad|iPod|BlackBerry|Kindle/i.test(navigator.userAgent) || (/Android|webOS|iPhone|iPad|iPod|BlackBerry|Kindle/i.test(navigator.platform))),
		itemArray:null,
		containersArray:null,
		numberCollected:0,
		gameActive:false,
		container_positions_arr:null,
		lastTimestamp: 0,
		intervalCap: 0,
		clawLeft:0,
		itemleft:0,
		item_selected_id:null,
		item_selected:false,
		hovered_container:"none",
		item_dragging:false,
		audio: new Audio(),
		pause:null,
		performance_mode:null,
		item_poss_arr:[],
		clawArray:[],
		level_end: null,
		objectCount:0,
		item_click_counter:0,
		game_paused:false,
		itemDistance:15,
		containerDistance:20,
		crateDelay:2,
		timer:null,
		leftTraffic:null,
		rightTraffic:null,
		feedBack:null,
		playAgain:null,
		gameTitle:null,
		rocks:null,
		
		init:function(){
			this.containersArray = [];
			this.itemArray = [];
			this.clawArray = [];
			this.game_times=[];
			this.container_positions_arr = [0,1,2,3];
			this.caChLevelData = new CaChLevelData();
			this.level_data = [1,2,3,4,5];
			var background = $('<div>').attr('class', 'cach_background');
			$('#cach_holder').append(background);
			var background_css = ({
								"position":"absolute",
								"left":"0%",
								"top":"0%",
								"width":"100%",
								"height":"100%",
								'background-image': 'url(images/game_background.jpg)',
								'background-repeat': 'no-repeat',
								'background-position': '0% 0%',
								'background-size': '100% 100%'
									});
			background.css(background_css);
			var that = this;
			that.set_mouse_follow();
			this.leftTraffic = new CaChTrafficLights('left');
			this.rightTraffic = new CaChTrafficLights('right');
			this.leftTraffic.stop();
			this.rightTraffic.stop();
			this.leftTraffic.hide();
			this.rightTraffic.hide();
			this.rocks = new CaChRocks();
			this.rocks.hide();
			this.gameTitle = new CaChGameTitle(this);
			//this.audio.playAudio("cargo_chaos", 1);
		},
		set_mouse_follow:function(){
			var that = this;
			$('#cach_holder').on('mousemove', function(e){
				if (that.item_selected) { 
				   var offset = $('#wrapper').offset();	
				    var left_pos = e.pageX - offset.left;
				    var top_pos = e.pageY - offset.top;
				    $('.cach_item' + that.item_selected_id).css('left', left_pos -25);
				    var item_height =$('.cach_item' + that.item_selected_id).height();
				    if (!window.sb_ie){
					    $('.cach_item' + that.item_selected_id).css('top', (top_pos- (item_height/2)));
				    } else {
					    $('.cach_item' + that.item_selected_id).css('top', (top_pos - 70));
				    }
				   }
			});
		},		
		set_holder_listener:function(){
		 var that =  this;
			$('#cach_holder').on('click',function(e){
				// that.item_click_counter++;
				// if (that.item_click_counter >= 1){
					$('#cach_holder').off('click');
					if(that.hovered_container==="none"){
						that.item_click_counter = 0;
					    $('#cach_holder').css('cursor','auto');
						$('.cach_item' + that.item_selected_id).css('pointer-events', 'auto'); 
						 var i =null;
							that.itemArray[that.item_selected_id].toggle_item_select_image(false);
				   			TweenMax.to( $('.cach_item' + that.item_selected_id), 0.5, {css:{left:that.item_poss_arr[1], top:that.item_poss_arr[0]}, onComplete:function(){
						 	that.item_poss_arr = [];
						 	that.item_selected = false;
						    that.deselectAll();
					  	}});
				}else{
					that.item_selected = false;
				}
			});
		},
		item_selection_handler:function(_is_selected){
			var that = this;
			that.item_selected = _is_selected;
			if(_is_selected){  
					 $('#cach_holder').css('cursor','move');
					 var i = null;
						for(i = 0; i < that.itemArray.length; i++){
							if(that.itemArray[i].selected) {
								that.itemArray[i].toggle_item_select_image(true);
							}else{
								that.itemArray[i].toggle_item_select_image(false);
							}
						}
						 		that.set_holder_listener();
					}
		},
		beginGame:function(){
			var that = this;
			this.removeTrain();
			this.removeItems();
			this.removeClaws();
			this.containersArray = [];
			this.itemArray = [];
			this.clawArray = [];
			this.container_positions_arr=[0,1,2,3];
			this.addContainers();
			this.objectCount = 0;
			this.numberCollected=0;
			this.feedBack = new CaChFeedback();
			this.playAgain = new CaChPlayAgain(this);
			this.rocks.show();
			setTimeout(function(){
				that.leftTraffic.show()
				that.rightTraffic.show()
			}, 500);
			setTimeout(function(){
					that.feedBack.show(that.caChLevelData.currentLevel+1,that,'false');
				}, 1200);
			setTimeout(function(){
				that.do_item_drop();
				that.gameActive = true;
					
				that.leftTraffic.go()
				that.rightTraffic.go()
				that.addTimer();
			}, 3300);
		},
		redoCurrentLevel:function(){
			var that = this;
			setTimeout(function(){
					that.beginGame();
				}, 1000);
		},
		addTimer:function(){
			this.timer = new CaChTimer();
			this.timer.startTimer(this.caChLevelData.game_times[this.caChLevelData.currentLevel],this.caChLevelData.currentLevel+1,this);
		},
		do_item_drop:function(){
				var amount = this.caChLevelData.levelItemsArray[this.caChLevelData.currentLevel];
				var i = null;
					var that = this;
				for(i = 0; i < amount; i++){
					this.claw = $('<div>').attr('id', 'claw'+i);
					switch (this.caChLevelData.currentLevel) {
						case 0:
							this.itemDistance = 15;
							this.clawLeft = 30;
							this.itemLeft = 33;
						break;
						case 1:
							this.itemDistance = 12;
							this.clawLeft = 30;
							this.itemLeft = 33;
						break
						case 2:
							this.itemDistance = 11;
							this.clawLeft = 11;
							this.itemLeft = 14;
						break
						case 3:
							this.itemDistance = 9;
							this.clawLeft = 3;
							this.itemLeft = 6;
						break;
						case 4:
							this.itemDistance = 7.2;
							this.clawLeft = 2;
							this.itemLeft = 5;
						break;
					}
					this.claw.css({
						'position':'absolute',
						'width': '13.45%', 
						'height': '21.49%',
						'left':100+(i*this.itemDistance)+'%',
						'top':'15%',
						'z-index':'10',
						'background-repeat': 'no-repeat',
						'background-size': '749.61% 1444.35%',
						'background-position': '100% 48.7%',
						'background-image': 'url(images/cargochaos.png)'
						});
						var item = new CaChItem(i,this);	
						item.create();
						this.itemArray.push(item);
						this.clawArray.push(this.claw);
						$('.cach_item' + i).css({'left':103+(i*this.itemDistance)+'%','top':'25%'});
						$('#cach_holder').append(this.claw);
						TweenMax.to($(that.claw), 0.5, {css:{left:this.clawLeft+(i*this.itemDistance)+'%'},delay:(i*that.crateDelay)});
						TweenMax.to($('.cach_item' + i), 0.5, {css:{left:this.itemLeft+(i*this.itemDistance)+'%'},onComplete:this.doClawDrop,onCompleteParams:[i,this,this.claw],delay:(i*that.crateDelay)});
				}
			this.claw.attr('draggable', 'false');
			// if (that.gameActive === true) { 
					setTimeout(function(){
						that.enable_item_interaction();
						}, 500);
					 
				 // }
	},
	doClawDrop:function(_item,_that,_claw){
			var item = _item;
			var that  = _that;
			_claw.css({'background-position': '100% 40.7%'});
			var rnd_top = Math.random() * (52 - 48 + 1) + 48;
			$('.cach_item' + item).css('z-index','50000');
			TweenMax.to($('.cach_item' + item), 0.7, {css:{top:rnd_top+'%'},ease:Bounce.easeOut,onComplete:function(){
				TweenMax.to($('#claw' + item), 0.7, {css:{left:-30+'%'}});
			}});
	},
	enable_item_interaction:function(){
			var that = this;
			var x = null;
			for(x = 0; x < that.itemArray.length; x++){
				that.itemArray[x].toggle_drag('enable');
			}
			that.objectCount++;
			if (!that.is_mobile){
			}	 
	},
	addContainers:function(){
			var that = this;
			var amount = that.caChLevelData.levelContainersArray[that.caChLevelData.currentLevel];
			var item = null;
				var i = null;
					var wilson = $('<div>').attr('id', 'wilson');
					wilson.css({
						'position':'absolute',
						'width': '40.15%', 
						'height': '27.04%',
						'left':'30%',
						'z-index':'13',
						'background-repeat': 'no-repeat',
						'background-size': '251.19% 1148.08%',
						'background-position': '91.3% 87%',
						'background-image': 'url(images/cargochaos.png)'
						});
						$('#cach_holder').append(wilson);
				switch (this.caChLevelData.currentLevel) {
						case 0:
							// this.containerLeft = 38;
							// this.shapeLeft = 32;
							// this.leftWilson  = 31;
							this.containerLeft = 27;
							this.shapeLeft = 21;
							this.leftWilson  = 21;
							wilson.css({'background-position': '93% 87%','top':'62.2%'});
						break;
						case 1:
							this.containerLeft = 27;
							this.shapeLeft = 21;
							this.leftWilson  = 21;
							wilson.css({'background-position': '93% 87%','top':'62.2%'});
						break
						case 2:
							this.containerLeft = 17;
							this.shapeLeft = 11;
							this.leftWilson = 10;
							wilson.css({'background-position': '0% 99%','top':'62.7%'});
						break
						case 3:
							this.containerLeft = 17;
							this.shapeLeft = 11;
							this.leftWilson  = 10;
							wilson.css({'background-position': '0% 89%','top':'62.7%'});
						break;
						case 4:
							this.containerLeft = 17;
							this.shapeLeft = 11;
							this.leftWilson  = 10;
							wilson.css({'background-position': '0% 99%','top':'62.7%'});
						break;
					}
						TweenMax.to(wilson, 3, {startAt:{left:-121+(amount*this.containerDistance)+'%'},css:{left:this.leftWilson+((amount)*this.containerDistance)+'%'},onComplete:function(){
							TweenMax.to($('#wilson'), 3, {left:120+'%'});
						}});
				for(i = 0; i < amount; i++){
					item = new CaChContainer(i,this);
					item.create();
					that.containersArray.push(item);
					$(".cach_container"+that.container_positions_arr[i]).css("visibility","visible");
					TweenMax.to($(".cach_container"+that.container_positions_arr[i]), 3, {startAt:{left:-113.5+(i*this.containerDistance)+'%'},css:{left:this.containerLeft+(i*this.containerDistance)+'%'}});
					TweenMax.to($('.shape_'+"cach_container"+that.container_positions_arr[i]), 3, {startAt:{left:-120+(i*this.containerDistance)+'%'},css:{left:this.shapeLeft+(i*this.containerDistance)+'%'}});
					item.left = 37.5+(i*15);
					}
		},
		removeTrain:function(_is_shuffle){
			var that = this;
				var i = null;
				for(i = 0; i < this.containersArray.length; i++){
					this.containersArray[i].disable();
					this.containersArray[i].holder.remove();
					// this.containersArray[i].carriage.remove();
					this.containersArray[i].carriageHolder.remove();
				}
				$('#wilson').remove();
				if(_is_shuffle){
					that.containersArray =[];
					that.container_positions_arr = that.shuffleArray(that.container_positions_arr);
				 	that.addContainers();
				}
		},
		removeItems:function(){
				var i = null;
				for(i = 0; i < this.itemArray.length; i++){
					this.itemArray[i].holder.remove();
				}
		},
		removeClaws:function(){
				var i = null;
				for(i = 0; i < this.clawArray.length; i++){
					this.clawArray[i].remove();
				}
		},
		deselectOthers:function(_id){
			var that = this;
				var id = _id;
				var i = null;
				for(i = 0; i < this.itemArray.length; i++){
					if(i!=_id){
						this.itemArray[i].selected =false;
					}
					if(i === _id){
						that.item_selected = true;
						that.item_selected_id = i;
					}
				}
		},
		deselectAll:function(){
			var that = this;
				var i = null;
				for(i = 0; i < this.itemArray.length; i++){
						this.itemArray[i].selected =false;
						this.itemArray[i].click_counter =0;
						 $(".cach_item"+this.itemArray[i].id).css('pointer-events', 'auto');
				}
				 that.item_selected = false;
		},
		checkForMatch:function(_container){
			var container = _container;
			var i =null;
			var that = this;
			for(i = 0; i < this.itemArray.length; i++){
					if(this.itemArray[i].selected===true&&this.itemArray[i].type===container.containerArray[container.id]){
						this.itemArray[i].holder.draggable({
			  				revert:false
			  			});
						TweenMax.to(this.itemArray[i].holder,0.1,{css:{'alpha':1, 'top':(container.top + 2)+ '%'},delay:0.2,onComplete:that.itemArray[i].removeItem,onCompleteParams:[that.itemArray[i]]});
						that.numberCollected++;
					setTimeout(function(){
						that.checkComplete();
						$(".shape_cach_container"+container.containerArray[container.id]).css('z-index','0');
						}, 100);	
					}
			}
		},
		checkForMatch_2:function(_container){
			var container = _container;
			var i =null;
			var that = this;
			for(i = 0; i < this.itemArray.length; i++){
					if(this.itemArray[i].selected===true && this.itemArray[i].type === container.containerArray[container.id]){
						that.item_selected = false;
						 that.deselectAll();
						 $('#cach_holder').off('click');
						 that.item_click_counter = 0;
						 $('#cach_holder').css('cursor','auto');
						 $('.cach_item' + that.item_selected_id).css('pointer-events', 'auto'); 
						this.numberCollected++;
						TweenMax.to(this.itemArray[i].holder,0.1,{css:{'alpha':1, 'top':(container.top + 2)+ '%'},delay:0.2,onComplete:that.itemArray[i].removeItem,onCompleteParams:[that.itemArray[i]]});
						setTimeout(function(){
						that.checkComplete();
						$(".cach_container"+container.containerArray[container.id]).css('z-index','0');
						}, 500);
					} else{
						if(this.itemArray[i].selected===true && this.itemArray[i].type!=container.containerArray[container.id]){
							 that.item_selected = false;
							 $('#cach_holder').off('click');
							 that.item_click_counter = 0;
							 $('#cach_holder').css('cursor','auto');
							 $('.cach_item' + that.item_selected_id).css('pointer-events', 'auto'); 
							 var i =null;
							for(i = 0; i < that.itemArray.length; i++){
								that.itemArray[i].toggle_item_select_image(false);
							}
							TweenMax.to( $('.cach_item' + that.item_selected_id), 0.5, {css:{left:that.item_poss_arr[1], top:that.item_poss_arr[0]}, onComplete:function(){
								 that.item_poss_arr = [];
							}});
						} 
					}
			}
		},
		checkComplete:function(){
			var that = this;
			//if(that.numberCollected===that.itemArray.length-2){
				//this.audio.playAudio("can_do_it", 1);
			//}
			if(that.numberCollected===that.itemArray.length){
				//that.audio.playAudio("cool", 1);
				that.objectCount = 0;
				that.item_selected = false;
				this.leftTraffic.stop();
				this.rightTraffic.stop();
				this.timer.pauseTimer();
				setTimeout(function(){
					var i = null;
					for(i = 0; i < that.containersArray.length; i++){
						that.containersArray[i].disable();
					}
					that.animateOutContainers()
				  		 $("#cach_holder").get(0).removeEventListener("touchstart", this.touchHandler, true);
				  		 $("#cach_holder").get(0).removeEventListener("touchmove", this.touchHandler, true);
				  		 $("#cach_holder").get(0).removeEventListener("touchcancel", this.touchHandler, true);
				  		 $("#cach_holder").get(0).removeEventListener("touchend", this.touchHandler, true);
					}, 2000);
			}
		},
		animateOutContainers:function(){
							var that = this;
							var amount = that.caChLevelData.levelContainersArray[that.caChLevelData.currentLevel];
								if(amount==4){
									var wilsonMove = amount-1.5;
								}else{
									var wilsonMove = amount-1;
								}
							TweenMax.to(wilson, 1, {css:{left:40+(wilsonMove*that.containerDistance)+'%'},onComplete:function(){
							TweenMax.to($('#wilson'), 2, {left:140+(wilsonMove*that.containerDistance)+'%',onComplete:function(){
									that.goToNextLevel();
								}});
							var item = null;
							var i = null;
							for(i = 0; i < amount; i++){
								TweenMax.to($(".cach_container"+that.container_positions_arr[i]), 2, {css:{left:133+(i*that.containerDistance)+'%'}});
								TweenMax.to($('.shape_'+"cach_container"+that.container_positions_arr[i]), 2, {css:{left:129+(i*that.containerDistance)+'%'}});
							}
						}});
		},
		goToNextLevel:function(){
			if(this.caChLevelData.currentLevel===this.caChLevelData.numberOfLevels){
				/////game complete//////
				this.leftTraffic.hide();
				this.rightTraffic.hide();
				this.gameTitle.completed();
			}else{
				if(this.gameActive===true){
					this.numberCollected=0;
					this.caChLevelData.currentLevel++;
					var that = this;
					that.beginGame();
				}
			}
		},
		timeUp: function(){
			var that = this;
			this.feedBack.show(this.caChLevelData.levelItemsArray[this.caChLevelData.currentLevel],that,'true');
			this.gameActive = false;
			this.timer.pauseTimer();
			this.item_selected = false;
			this.leftTraffic.stop();
			this.rightTraffic.stop();
			this.numberCollected=0;
			var i = null;
			for(i = 0; i < this.itemArray.length; i++){
				this.itemArray[i].removeInteraction()
			}
			for(i = 0; i < this.containersArray.length; i++){
				this.containersArray[i].removeInteraction()
			}
		},
		// update : function(delta) {
			// var that = this;
			// if(that.item_selected){
			// }
		// },
		addShuffledContainers:function(){
			var that = this;
							var amount = that.caChLevelData.levelContainersArray[that.caChLevelData.currentLevel];
							if(this.caChLevelData.currentLevel===0){
								var wilsonMove = amount;
							}else{
								wilsonMove = amount-1;
							}
			TweenMax.to(wilson, 1, {css:{left:31+(wilsonMove*this.containerDistance)+'%'},onComplete:function(){
							TweenMax.to($('#wilson'), 2, {left:131+(wilsonMove*that.containerDistance)+'%',onComplete:function(){
									that.removeTrain(true);
								}});
							var item = null;
							var i = null;
							for(i = 0; i < amount; i++){
								TweenMax.to($(".cach_container"+that.container_positions_arr[i]), 2, {css:{left:133+(i*that.containerDistance)+'%'}});
								TweenMax.to($('.shape_'+"cach_container"+that.container_positions_arr[i]), 2, {css:{left:129+(i*that.containerDistance)+'%'}});
							}
						}});
		},
		shuffleArray:function(array) {
			  var currentIndex = array.length
			    , temporaryValue
			    , randomIndex;
			  while (0 !== currentIndex) {
			    randomIndex = Math.floor(Math.random() * currentIndex);
			    currentIndex -= 1;
			    temporaryValue = array[currentIndex];
			    array[currentIndex] = array[randomIndex];
			    array[randomIndex] = temporaryValue;
  			 }
			return array;
		}
	});
});