define([
         "jquery",
         "lib/util/classUtils",
         "lib/util/IsEventSupported",
         "thirdparty/Stats",
         "lib/TweenMax.min",
         "CargoChaos/Audio"
     
         ],
         function($, classUtils,IsEventSupported, Stats, TweenMax, Audio) {
	
	"use strict";
	return classUtils.create({
		playButton:null,
		instructionsButton:null,
		background:null,
		game:null,
		instructions:null,
		textBackground:null,
		level:null,
		audio:new Audio(),
		completedBoolean:false,
		init: function(_game){
			this.game = _game;
			this.background = $('<div>').attr('id', 'cach_playagain');
			this.background.css({
				'position':'absolute',
				'width': '100%', 
				'height': '100%',
				'top': '0%',
				'left': '0%',
				'z-index':'20000',
				'background-size': '100% 100%',
				'background-image': 'url(images/game_title.jpg)',
				'background-repeat': 'no-repeat'
				});
			$('#cach_holder').append(this.background);
			this.playButton = $('<div>').attr('id', 'cach_play_title_btn');
			this.playButton.css({
				'position':'absolute',
				'width': '17.27%', 
				'height': '28.25%',
				'top': '67%',
				'left': '29%',
				'z-index':'20000',
				'background-image': 'url(images/cargochaos.png)',
				'background-repeat': 'no-repeat',
				'background-size': '584.05% 1098.77%',
				'background-position': '55% 41.7%'
				});
			$('#cach_holder').append(this.playButton);
			this.instructionsButton = $('<div>').attr('id', 'cach_instructions_title_btn');
			this.instructionsButton.css({
				'position':'absolute',
				'width': '17.27%', 
				'height': '28.25%',
				'top': '67%',
				'left': '52%',
				'z-index':'20000',
				'background-image': 'url(images/cargochaos.png)',
				'background-repeat': 'no-repeat',
				'background-size': '584.05% 1098.77%',
				'background-position': '55% 52.2%'
				});
			$('#cach_holder').append(this.instructionsButton);
			this.show();
		},
		show: function(){
			var that = this;
			this.playButton.show();
			this.instructionsButton.show();
			this.background.show();
			TweenMax.to(that.playButton,0.7,{startAt:{scale:0},scale:1,ease:Elastic.easeOut})
			TweenMax.to(that.instructionsButton,0.7,{startAt:{scale:0},scale:1,ease:Elastic.easeOut})
			// TweenMax.to(that.background,0.7,{startAt:{scale:0},scale:1,ease:Elastic.easeOut})
			this.playButton.on("mouseover", function(){
				//that.audio.playAudio("play", 1);
				TweenMax.to(that.playButton,0.7,{scale:1.05,ease:Elastic.easeOut})
			});
			this.playButton.on("mouseout", function(){
				TweenMax.to(that.playButton,0.7,{scale:1,ease:Elastic.easeOut})
			});
			this.playButton.on("click", function(){
				that.playButton.off("click");
				that.playButton.off("mouseover");
				that.instructionsButton.off("click");
				that.instructionsButton.off("mouseover");
				that.hide();
				that.game.beginGame();
			});
			this.instructionsButton.on("mouseover", function(){
				//that.audio.playAudio("help", 1);
				TweenMax.to(that.instructionsButton,0.7,{scale:1.05,ease:Elastic.easeOut})
			});
			this.instructionsButton.on("mouseout", function(){
				TweenMax.to(that.instructionsButton,0.7,{scale:1,ease:Elastic.easeOut})
			});
			this.instructionsButton.on("click", function(){
				// that.playButton.off("click");
				// that.playButton.off("mouseover");
				that.instructionsButton.off("click");
				that.instructionsButton.off("mouseover");
				// that.hide();
				that.showInstructions();
			});
		},
		hide: function(){
			var that = this;
			TweenMax.to(that.playButton,0.5,{scale:0,ease:Expo.easeIn});
			TweenMax.to(that.instructionsButton,0.5,{scale:0,ease:Expo.easeIn,onComplete:function(){
				that.instructionsButton.remove();
				that.playButton.remove();
				that.background.remove();
				if(that.instructions!=null)
					that.instructions.remove();
			}});
		},
		hideCompleted: function(){
			var that = this;
			TweenMax.to(that.playButton,0.5,{scale:0,ease:Expo.easeIn});
			TweenMax.to(that.level,0.5,{scale:0,ease:Expo.easeIn,onComplete:function(){
				that.instructionsButton.remove();
				that.playButton.remove();
				that.background.remove();
				that.textBackground.remove();
				that.level.remove();
			}});
		},
		showInstructions: function(){
			this.instructions = $('<div>').attr('id', 'cach_instructions_title');
			this.instructions.css({
				'position':'absolute',
				'width': '100%', 
				'height': '100%',
				'top': '0%',
				'left': '0%',
				'z-index':'20000',
				'background-image': 'url(images/helpScreen.jpg)',
				'background-repeat': 'no-repeat'
				});
			$('#cach_holder').append(this.instructions);
			this.playButton.css({
				'top': '67%',
				'left': '30%',
				'z-index':'200001',
				});
		},
		completed:function(){
			var that = this;
			this.completedBoolean = true;
			this.background = $('<div>').attr('id', 'cach_playagain');
			this.background.css({
				'position':'absolute',
				'width': '100%', 
				'height': '100%',
				'top': '0%',
				'left': '0%',
				'z-index':'20000',
				'background-image': 'url(images/game_complete.jpg)',
				'background-repeat': 'no-repeat'
				});
			$('#cach_holder').append(this.background);
			
			this.playButton = $('<div>').attr('id', 'cach_play_title_btn');
			this.playButton.css({
				'position':'absolute',
				'width': '17.27%', 
				'height': '28.25%',
				'top': '60%',
				'left': '40%',
				'z-index':'20000',
				'background-image': 'url(images/cargochaos.png)',
				'background-repeat': 'no-repeat',
				'background-size': '584.05% 1098.77%',
				'background-position': '55% 41.7%'
				});
			$('#cach_holder').append(this.playButton);
				
			this.textBackground = $('<div>').attr('id', 'cach_text_background');
			this.textBackground.css({
				'position':'absolute',
				'width': '108.47%', 
				'height': '29.98%',
				'top': '10%',
				'left': '0%',
				'z-index':'60000',
				'background-image': 'url(images/cargochaos.png)',
				'background-size': '100.84% 1035.26%',
				'background-repeat': 'no-repeat',
				'background-position': '0% 0%'
				});
			$('#cach_holder').append(this.textBackground);
			
			this.level = $('<div>').attr('id', 'cach_level');
			this.level.css({
				'position':'absolute',
				'width': '63.45%', 
				'height': '27.04%',
				'top': '10%',
				'left': '-70%',
				'z-index':'60001',
				'background-image': 'url(images/cargochaos.png)',
				'background-repeat': 'no-repeat',
				'background-size': '158.93% 1148.08%',
				'background-position': '0% 31.2%'
				});
			$('#cach_holder').append(this.level);
			
			TweenMax.to(this.level,0.3,{css:{left:18+'%'},delay:0.3});
			TweenMax.to(this.textBackground,0.7,{startAt:{alpha:0},alpha:1});
			
			this.playButton.on("mouseover", function(){
				TweenMax.to(that.playButton,0.7,{scale:1.05,ease:Elastic.easeOut});
			});
			this.playButton.on("mouseout", function(){
				TweenMax.to(that.playButton,0.7,{scale:1,ease:Elastic.easeOut});
			});
			
			this.playButton.on("click", function(){
				that.playButton.off("click");
				that.playButton.off("mouseover");
				that.instructionsButton.off("click");
				that.instructionsButton.off("mouseover");
				if(that.completedBoolean){
					that.hideCompleted();
					that.game.caChLevelData.currentLevel=0;
					that.completedBoolean===false;
				}else{
					that.hide();
				}
				that.game.beginGame();
			});
		}
	});
	});