define([
         "jquery",
         "thirdparty/jquery/plugins/jquery-ui-1.9.1.custom.min",
         "lib/util/classUtils",
         "lib/util/IsEventSupported",
         "lib/TweenMax.min",
         "thirdparty/jquery/plugins/jquery.ui.touch-punch"
         ],
         function($,ui, classUtils, IsEventSupported, TweenMax) {
	"use strict";
	return classUtils.create({
		game:null,
		id:null,
		holder:null,
		text:null,
		width:15,
		height:10,
		top:10,
		left:5,
		distanceBetween:5,
		type:null,
		selected:false,
		item:null,
		is_hornswoggler_item:false,
		item_side:null,
		hornswoggler_item_tween_1:null,
		hornswoggler_item_tween_2:null,
		hornswoggler_item_tween_3:null,
		hornswoggler_tween_arr:[],
		is_tweening:null,
		click_counter:0,
		
		
		init:function(_id,_that,_is_hornswoggler_item, _side){	
		this.id = _id;
		this.game = _that;
		if(_is_hornswoggler_item){ 
		this.is_hornswoggler_item = _is_hornswoggler_item;
		
		if (_side === 1){  
		  this.item_side = "left";
				}else{
		  this.item_side = "right";	
				}
			}
	 
		},
		create:function(){
			this.item = 'cach_item' + this.id;
			this.holder = $('<div>').attr('class', this.item);
			this.holder.css({
				'position':'absolute',
				'top': '15%',
				"-webkit-user-select": 'none'
				});
			$('#cach_holder').append(this.holder);
			this.selectType();
			 this.initTouch();
		},
		
		touchHandler:function(event){
		    var touches = event.changedTouches,
		        first = touches[0],
		        type = "";
		 
		    switch(event.type){
		        case "touchstart": type = "mousedown"; break;
		        case "touchmove":  type="mousemove"; break;
		        case "touchend":   type="mouseup"; break;
		        default: return;
		    }
		    var simulatedEvent = document.createEvent("MouseEvent");
		    simulatedEvent.initMouseEvent(type, true, true, window, 1,
		                              first.screenX, first.screenY,
		                              first.clientX, first.clientY, false,
		                              false, false, false, 0/*left*/, null);
		    first.target.dispatchEvent(simulatedEvent);
		    event.preventDefault();
		},

	initTouch:function(){
		if ($("#cach_holder").get(0).addEventListener) {
			 $("#cach_holder").get(0).addEventListener("touchstart", this.touchHandler, true);
	  		 $("#cach_holder").get(0).addEventListener("touchmove", this.touchHandler, true);
	  		 $("#cach_holder").get(0).addEventListener("touchcancel", this.touchHandler, true);
	  		 $("#cach_holder").get(0).addEventListener("touchend", this.touchHandler, true);
		}
},
		selectType:function(){
			var amount = this.game.caChLevelData.levelVariety[this.game.caChLevelData.currentLevel];
			this.type = Math.floor(Math.random()*amount);
			this.holder.css('background-size', '1175.31% 2211.11%');
			this.holder.css('height','12.13%'); 
			this.holder.css('width','7.31%'); 
			this.holder.css('background-image', 'url(images/cargochaos.png)');
			this.holder.css('background-repeat','no-repeat');
			this.holder.css('overflow','hidden');
			switch (this.type+1) {
			case 1: // square
					this.holder.css('background-position', '73.4% 92.5%'); 
					// if(window.sb_ie)
				// {
					// this.holder.css({'background-position':(300 * -0.762) + 'px ' + (2 * -0.762) + 'px'});
					// this.holder.css({'background-size':'auto auto'});
				// }
				break;
			case 2: // circle
					this.holder.css('background-position', '85% 97.2%');
						// if(window.sb_ie)
				// {
					// this.holder.css({'background-position':(848 * -0.762) + 'px ' + (2 * -0.762) + 'px'});
					// this.holder.css({'background-size':'auto auto'});
				// }
			break;
			case 3: //star
					this.holder.css('background-position', '82.4% 61.7%'); 
						// if(window.sb_ie)
				// {
					// this.holder.css({'background-position':(150 * -0.762) + 'px ' + (2 * -0.762) + 'px'});
					// this.holder.css({'background-size':'auto auto'});
				// }
			break;
			case 4://diamond
					this.holder.css('background-position', '82.4% 92.5%'); 
					// if(window.sb_ie)
				// {
					// this.holder.css({'background-position':(554 * -0.762) + 'px ' + (2 * -0.762) + 'px'});
					// this.holder.css({'background-size':'auto auto'});
				// }
			break;
		}
		},
		toggle_drag: function(_toggle){
			var that = this;
				var target = "."+this.item; 
				that.addInteraction();
		},
		
		toggle_item_select_image:function(_selected){
			var that = this
			if(_selected){
					this.holder.css('height','14.04%'); 
					this.holder.css('width','8.26%');
					this.holder.css('background-size', '1175.31% 2211.11%'); 
				// if(window.sb_ie){
					// this.holder.css({'background-position':(642 * -0.762) + 'px ' + (2 * -0.762) + 'px'});
					// this.holder.css({'background-size':'auto auto'});
				// }	
				}else{
					this.holder.css('height','12.13%'); 
					this.holder.css('width','7.31%'); 
					this.holder.css('background-size', '1220.51% 2211.11%');
				}
			switch (that.type+1) {
			case 1: // square
				if(_selected){
					this.holder.css('background-position', '49.8% 84.7%');
					this.holder.css('z-index','55000');
				// if(window.sb_ie){
					// this.holder.css({'background-position':(642 * -0.762) + 'px ' + (2 * -0.762) + 'px'});
					// this.holder.css({'background-size':'auto auto'});
				// }	
				}else{
					this.holder.css('background-position', '73.4% 92.5%');
					this.holder.css('z-index','53000');
				// if(window.sb_ie){
					// this.holder.css({'background-position':(300 * -0.762) + 'px ' + (2 * -0.762) + 'px'});
					// this.holder.css({'background-size':'auto auto'});
				// }
				}
				break;
			case 2: // circle
				if(_selected){
					this.holder.css('background-position', '44.4% 95%');
					this.holder.css('z-index','55000');
				// if(window.sb_ie){
					// this.holder.css({'background-position':(1336 * -0.762) + 'px ' + (2 * -0.762) + 'px'});
					// this.holder.css({'background-size':'auto auto'});
					// }	
				}else{
					this.holder.css('background-position', '85% 97.2%');
					this.holder.css('z-index','53000');
						// if(window.sb_ie){
					// this.holder.css({'background-position':(848 * -0.762) + 'px ' + (2 * -0.762) + 'px'});
					// this.holder.css({'background-size':'auto auto'});
				// }
				}
			break;
			case 3: //star
				if(_selected){
					this.holder.css('z-index','55000');
					this.holder.css('background-position', '49.8% 79.4%');
				// if(window.sb_ie){
					// this.holder.css({'background-position':(222 * -0.762) + 'px ' + (2 * -0.762) + 'px'});
					// this.holder.css({'background-size':'auto auto'});
				// }
				}else{
					this.holder.css('z-index','53000');
					this.holder.css('background-position', '82.4% 61.7%');
				// if(window.sb_ie){
					// this.holder.css({'background-position':(150 * -0.762) + 'px ' + (2 * -0.762) + 'px'});
					// this.holder.css({'background-size':'auto auto'});
				// }
				}
			break;
			case 4://diamond
				if(_selected){
					this.holder.css('background-position', '44.4% 89.8%');
					this.holder.css('z-index','55000');
						// if(window.sb_ie){
							// this.holder.css({'background-position':(378 * -0.762) + 'px ' + (2 * -0.762) + 'px'});
							// this.holder.css({'background-size':'auto auto'});
						// }
				}else{	
					this.holder.css('background-position', '82.4% 92.5%');
					this.holder.css('z-index','56000');
					// if(window.sb_ie){
						// this.holder.css({'background-position':(554 * -0.762) + 'px ' + (2 * -0.762) + 'px'});
						// this.holder.css({'background-size':'auto auto'});
					// }
				}
			break;
		}
		},
		
		addInteraction:function(){
			var that = this;
			var a = 60000;
			var target = "."+that.item; 
			if (IsEventSupported("touchstart")){
				$(target).on("dragstart", function(event, ui){
        			event.stopPropagation();
        			$(this).css("z-index", a++);
       			});
				 $(target).draggable({
			  	 start: function(event, ui) { 
			  	 	// $(this).css("z-index", a++);
			  	 	that.selected = true;
			  	// 	that.holder.css({'background-color':'orange'});
			  	 	that.game.deselectOthers(that.id);
			  	 },
			  	 stop: function(event, ui) {
					//that.holder.css({'background-color':'green'});
  				},
			  	revert:true
			 });
			}else{	
				$(target).on('mousedown',function(e){
					e.preventDefault(); 
										if(that.selected === false && that.game.item_selected === false) { 
								        	$(this).css("z-index", a++);
								        	that.game.item_poss_arr[0] = $("."+that.item).position().top;
											that.game.item_poss_arr[1] =  $("."+that.item).position().left;
										    that.selected = true;
										    $("."+that.item).css('pointer-events', 'none');
								        }else{
								        	 that.selected = true;
								          that.game.item_selected = true;
								        }
							that.game.deselectOthers(that.id);
							that.game.item_selection_handler(that.selected);
							that.click_counter++;
				});
				$(target).on('mouseup',function(e){
					e.preventDefault(); 
					that.click_counter=0;
				});
					$(target).on('mouseenter',function(e){
						e.preventDefault(); 
						});
					 $(target).on('mouseleave',function(e){
						 e.preventDefault(); 
						});
			}	
		},
		removeItem:function(_that){
			var that = _that;
			that.holder.remove();
		},
		removeInteraction:function(){	
			var target = "."+this.item; 
			if (IsEventSupported("touchstart")){
				$(target).off('mousedown');
				$(target).off('mouseup');
				$(target).off('mouseleave');
				$(target).off('mouseenter');
				  		  $("#cach_holder").get(0).removeEventListener("touchstart", this.touchHandler, true);
						  $("#cach_holder").get(0).removeEventListener("touchmove", this.touchHandler, true);
						  $("#cach_holder").get(0).removeEventListener("touchend", this.touchHandler, true);
						  $("#cach_holder").get(0).removeEventListener("touchcancel", this.touchHandler, true);
					}else{
				$(target).off('mousedown');
				$(target).off('mouseup');
				$(target).off('mouseleave');
				$(target).off('mouseenter');
			}
		}	
	});
});