define([
         "jquery",
         "lib/util/classUtils",
         "lib/util/IsEventSupported",
         "lib/TweenMax.min",
         "CargoChaos/Audio"
     
         ],
         function($, classUtils,IsEventSupported,TweenMax,Audio) {
	
	"use strict";
	return classUtils.create({
		button:null,
		background:null,
		game:null,
		audio: new Audio,
		init: function(_game){
			this.game = _game;
			this.background = $('<div>').attr('id', 'cach_playagain');
			this.background.css({
				'position':'absolute',
				'width': '65.15%', 
				'height': '25.48%',
				'top': '19%',
				'left': '18%',
				'z-index':'70000',
				'background-image': 'url(images/cargochaos.png)',
				'background-size': '154.8% 1218.37%',
				'background-repeat': 'no-repeat',
				'background-position': '0% 22.2%'
				});
			$('#cach_holder').append(this.background);
			this.button = $('<div>').attr('id', 'cach_play_again_btn');
			this.button.css({
				'position':'absolute',
				'width': '17.27%', 
				'height': '28.25%',
				'top': '45%',
				'left': '40%',
				'z-index':'70000',
				'background-image': 'url(images/cargochaos.png)',
				'background-repeat': 'no-repeat',
				'background-size': '584.05% 1098.77%',
				'background-position': '55% 41.7%'
				});
			$('#cach_holder').append(this.button);
			this.button.hide();
				this.background.hide();
		},
		show: function(){
			var that = this;
			this.button.show();
			this.background.show();
			TweenMax.to(that.button,0.7,{startAt:{scale:0},scale:1,ease:Elastic.easeOut});
			TweenMax.to(that.background,0.7,{startAt:{scale:0},scale:1,ease:Elastic.easeOut});
			this.button.on("mouseover", function(){
				//that.audio.playAudio("play_again", 1);
				TweenMax.to(that.button,0.7,{scale:1.1,ease:Elastic.easeOut});
			});
			this.button.on("mouseout", function(){
				TweenMax.to(that.button,0.7,{scale:1,ease:Elastic.easeOut});
			});
			this.button.on("click", function(){
				that.button.off("mouseover");
				that.hide();
				that.game.redoCurrentLevel();
				that.button.off("click");
			});
		},
		hide: function(){
			var that = this;
			TweenMax.to(that.button,0.5,{scale:0,ease:Expo.easeIn});
			TweenMax.to(that.background,0.5,{scale:0,ease:Expo.easeIn,onComplete:function(){
				that.button.hide();
				that.background.hide();
			}});
		}
	});
	});