define([
         "jquery",
         "lib/util/classUtils",
         "lib/util/IsEventSupported",
         "lib/TweenMax.min",
         "CargoChaos/Audio"
     
         ],
         function($, classUtils,IsEventSupported,TweenMax, Audio) {
	
	"use strict";
	return classUtils.create({
		timerBackground:null,
		lightArray:null,
		timeLimit:null,
		currentTime:0,
		active:false,
		started:false,
		game:null,
		shuffled1:false,
		shuffled2:false,
		currentLightTweened:null,
		firstUP:true,
		firstUPred:true,
		timeUp:false,
		audio: new Audio,
		isMobile: !!(/Android|webOS|iPhone|iPad|iPod|BlackBerry|Kindle/i.test(navigator.userAgent) || (/Android|webOS|iPhone|iPad|iPod|BlackBerry|Kindle/i.test(navigator.platform))),

		init: function(){
			this.lightArray = ['green','green','green','green','green','green','green','green','yellow','yellow','yellow','yellow','yellow','red','red','red'];
			this.timerBackground = $('<div>').attr('id', 'timerBackground');
					this.timerBackground.css({
						'position':'absolute',
						'width': '42.27%', 
						'height': '17.16%',
						'left':'28%',
						'top':'-6%',
						'z-index':'14',
						'background-repeat': 'no-repeat',
						'background-image': 'url(images/cargochaos.png)',
						'background-size': '238.60% 1809.09%',
						'background-position': '99% 68.5%'
						});
						$('#cach_holder').append(this.timerBackground);
						this.addLights();
		},
		addLights: function(){
			var i=null;
				for(i = 0; i < this.lightArray.length; i++){
						var lightOff = $('<div>').attr('id', this.lightArray[i]+'off'+i);
					lightOff.css({
						'position':'absolute',
						'width': '1.48%', 
						'height': '2.6%',
						'left':33+(i*2)+'%',
						'top':'3%',
						'z-index':14+i,
						'background-size': '100% 100%',
						'background-repeat': 'no-repeat',
						'background-image': 'url(images/'+this.lightArray[i]+'_off.png)'
						});
						$('#cach_holder').append(lightOff);
						var lightOn = $('<div>').attr('id', this.lightArray[i]+'on'+i);
					lightOn.css({
						'position':'absolute',
						'width': '3.18%', 
						'height': '5.2%',
						'left':32.1+(i*2)+'%',
						'top':'1.8%',
						'z-index':34+i,
						'background-repeat': 'no-repeat',
						'visibility':'hidden',
						'background-size': '100% 100%',
						'background-image': 'url(images/'+this.lightArray[i]+'_on.png)'
						});
						$('#cach_holder').append(lightOn);
				}
		},
		startTimer: function(_time,_level,_game){
			this.game = _game;
			this.timeLimit = _time;
			this.currentTime = 0;
			this.active = true;
			this.unpauseTimer();
			this.started = true;
			this.timeUp = false;
		},
		unpauseTimer: function()
		{
			var that = this;
			if(this.active){
				var that = this;
				clearInterval(this.timer);
				this.timer = setInterval(function(){
					that.update();
				}, 1000);
			}
		},
		update: function(){
			var that = this;
			this.currentTime += 1;
			var percentage = this.currentTime / this.timeLimit;
			if(!this.isMobile)
						var currentLight = '#'+this.lightArray[Math.floor(percentage/(1/this.lightArray.length))]+'on'+Math.floor(percentage/(1/this.lightArray.length));
			else
						var currentLight = '#'+this.lightArray[Math.floor(percentage/(1/this.lightArray.length)-1)]+'on'+Math.floor(percentage/(1/this.lightArray.length)-1);
			if(Math.floor(percentage/(1/this.lightArray.length))>12){
				var i = null;
				for(i = 0; i < this.lightArray.length; i++){
					$('#'+this.lightArray[i]+'on'+i).css('background-image','url(images/red_on.png)');	
						$('#'+this.lightArray[i]+'on'+i).css('visibility','visible');
						TweenMax.to($('#'+this.lightArray[i]+'on'+i),1,{startAt:{css:{'alpha':0}},css:{'alpha':1}});
						this.currentLightTweened = currentLight;
				}
				if(this.timeUp===false){
					//that.audio.playAudio("running_out", 1);
					this.timeUp=true;
				}
			}else{
				$(currentLight).css('visibility','visible');
				if(this.currentLightTweened!=currentLight|| this.firstUP){
					if(!this.isMobile){
						this.tweenLight(currentLight);
					}
					this.currentLightTweened = currentLight;
					this.firstUP = false;
				}
			}
			if(percentage>0.35 && this.game.caChLevelData.currentLevel>1){
				if(this.shuffled1===false&&this.game.gameActive===true){
					this.shuffled1=true;
					this.game.addShuffledContainers();
				}
			}
			if(percentage >= 1.2){
						that.endTimer();
			}		
		},
		tweenLight:function(_target){
			TweenMax.to($(_target),1,{startAt:{css:{'alpha':0}},css:{'alpha':1},ease:"Linear.easeNone"});
		},
		pauseTimer: function(){
			var i = null;
			clearInterval(this.timer);
			this.resetLights();
		},
		endTimer: function(){
			var that = this;
			that.pauseTimer();
			that.active = false;
			that.game.timeUp();
		},
		destroy: function(){
			this.endTimer();
			this.timer = null;
		},
		resetLights:function(){
				var i=null;
				for(i = 0; i < this.lightArray.length; i++){
					$('#'+this.lightArray[i]+'on'+i).css({
						'visibility':'hidden',
						'background-image': 'url(images/'+this.lightArray[i]+'_on.png)'
					});
				}
		}
	});
	});