define([
         "jquery",
         "lib/util/classUtils",
         "lib/util/IsEventSupported",
         "lib/TweenMax.min",
         ],
         function($, classUtils, IsEventSupported, TweenMax) {
		"use strict";
	return classUtils.create({
		trafficLight:null,
		lightOff:null,
		lightOn:null,
		game:null,
		width:8.05,
		height:13.17,
		
		init:function(_direction){
			this.trafficLight = $('<div>').attr('class', 'traffic_light'+_direction);
			this.trafficLight.css({
				'position':'absolute',
				'width':'11.02%', 
				'height':'25.99%',
				'top':'2%',
				'background-repeat': 'no-repeat',
				'z-index':'100000',
				'background-image': 'url(images/cargochaos.png)',
				'background-size': '915.38% 1194%'
								});
				if(_direction==="left"){
					this.trafficLight.css({'background-position':'51.8% 62.3%'})
				}else{
					this.trafficLight.css({'background-position':'94.6% 61.1%'})
				}
			this.lightOff = $('<div>').attr('id','lightoff'+_direction);
			this.lightOff.css({
						'position':'absolute',
						'width': this.width+'%', 
						'height': this.height+'%',
						'top':'14%',
						'background-repeat': 'no-repeat',
						// 'background-image': 'url(images/traffic_light_red.png)',
						'z-index':'100000',
						'background-image': 'url(images/cargochaos.png)',
						'background-size': '1252.63% 2356.58%',
						'background-position': '44.5% 100%'
						});
			this.lightOn = $('<div>').attr('id','lighton'+_direction);
			this.lightOn.css({
						'position':'absolute',
						'width': this.width+'%', 
						'height': this.height+'%',
						'top':'4%',
						'background-image': 'url(images/cargochaos.png)',
						'background-repeat': 'no-repeat',
						'z-index':'100000',
						'background-size': '1252.63% 2356.58%',
						'background-position': '54.1% 100%'
						// 'visibility' : 'hidden'
						});
				if(_direction==="left"){
					this.trafficLight.css('left','-2%');
					this.lightOff.css('left','1%');
					this.lightOn.css('left','1%');
				}else{
					this.trafficLight.css('left','91%');
					this.lightOff.css('left','91.4%');
					this.lightOn.css('left','91.6%');
				}	
			$('#cach_holder').append(this.trafficLight);
			$('#cach_holder').append(this.lightOff);	
			$('#cach_holder').append(this.lightOn);
		},
		go:function(){
			TweenMax.to($(this.lightOn),0.5,{startAt:{css:{'alpha':0}},css:{'alpha':1}});
			TweenMax.to($(this.lightOff),0.5,{css:{'alpha':0}});
		},
		stop:function(){
			TweenMax.to($(this.lightOff),0.5,{startAt:{css:{'alpha':0}},css:{'alpha':1}});
			TweenMax.to($(this.lightOn),0.5,{css:{'alpha':0}});
		},
		hide:function(){
			this.lightOn.hide()
			this.lightOff.hide()
			this.trafficLight.hide()
		},
		show:function(){
			this.lightOn.show()
			this.lightOff.show()
			this.trafficLight.show()
		}
	});
});