
/**
 * IsEventSupported.js
 * 
 * http://perfectionkills.com/detecting-event-support-without-browser-sniffing/
 * 
 */
define([], function() {
	
	"use strict";

	 return (function(){
		 var TAGNAMES = {
				 'select':'input','change':'input',
				 'submit':'form','reset':'form',
				 'error':'img','load':'img','abort':'img'
		 };
		 function isEventSupported(eventName) {
			 var el = document.createElement(TAGNAMES[eventName] || 'div');
			 eventName = 'on' + eventName;
		     var isSupported = (eventName in el);
		     if (!isSupported) {
		    	 el.setAttribute(eventName, 'return;');
		    	 isSupported = typeof el[eventName] == 'function';
		     }
		     el = null;
		     return isSupported;
		 }
		 return isEventSupported;
	 })();
	 
});